#include <Wire.h>  
#include <DS1307new.h>    // Unsere Uhr
#include <DS18B20.h>
#include <LiquidCrystal_I2C.h>

// ********************************************* //
//                 VARIABLES                     //
// ********************************************* //

DS18B20_List ds18b20(24); // pin 10
LiquidCrystal_I2C lcd1(0x20,20,4,12);  //  LCD Adress / Chars / Rows / PWM Pin
#define TempOnBoard 0x7059
#define TempMetal 0x9C6E
#define TempPlastik 0xF5
int Water_TempPin=23;
float Water_Temp = 25.5;
int Water_TempState=HIGH;

uint16_t startAddr = 0x0000;            // Start address to store in the NV-RAM
uint16_t lastAddr;                      // new address for storing in NV-RAM
uint16_t TimeIsSet = 0xaa55;            // Helper that time must not set again

float timestamp = 0;
int DaylightPowerPin = 22;    // Relay 1
int DaylightPowerState = HIGH;
float Sunrise = get_ts(10,30,0);  //34200;    // 9:30
float Sunset = get_ts(22,30,0);   //77400;    //21:30

// Hilfe für Loop ohne Delay -> mach nur was wenn es eine neue Sekunde ist
int loopTime =0;

// ********************************************* //
//       Sensor Variablen und Pin Layout         //
// ********************************************* //

int pumpD1=27;
int pumpD2=28;
int pumpD3=29;
int pumpD4=30;
int pumpD5=31;
int pumpD1State=LOW;
int pumpD2State=LOW;
int pumpD3State=LOW;
int pumpD4State=LOW;
int pumpD5State=LOW;

// ********************************************* //
//                   Main Code                   //
// ********************************************* //


void setup() {
  Serial.begin(9600);    // Ausgabe am PC
  pinMode(2, INPUT);                    // Test of the SQW pin, D2 = INPUT
  digitalWrite(2, HIGH);                // Test of the SQW pin, D2 = Pullup on
  
  lcd1.init();                      // initialize the first lcd 
  lcd1.backlight(255);    // Backlight ganz an
  
  pinMode(pumpD1, OUTPUT);
  pinMode(pumpD2, OUTPUT);
  pinMode(pumpD3, OUTPUT);
  pinMode(pumpD4, OUTPUT);
  pinMode(pumpD5, OUTPUT);
  
}

void loop() {
  lcd1.setCursor(0, 0);
  lcd1.print("LCD with 2 wires");
  lcd1.setCursor(0, 1);
  lcd1.print(millis()/1000);
	RTC.getTime();
        Duenung(RTC.daystamp);

	if(loopTime !=int(RTC.second)){
	    loopTime =int(RTC.second);
            switchLight();
		Serial.println (printTime());
		Serial.println (printDate());


            // Temperaturen auslesen
		float T_inside=ds18b20.get_temp_by_id(TempOnBoard);
		float T_air=ds18b20.get_temp_by_id(TempMetal); 
		float T_water=ds18b20.get_temp_by_id(TempPlastik);

                // Heizung Steuern
                if(Water_Temp-0.5>T_water && Water_TempState==HIGH){
                  Water_TempState=LOW;
                  digitalWrite(Water_TempPin,Water_TempState);
                }else if(Water_Temp+0.5<T_water && Water_TempState==LOW){
                  Water_TempState=HIGH;
                  digitalWrite(Water_TempPin,Water_TempState);
                }
        }
}
